#INCLUDE "dcdialog.CH"
#INCLUDE "dcmxbutt.CH"

#INCLUDE "appevent.ch"        && added

PROC appsys
return


FUNCTION Main()

LOCAL GetList[0], GetOptions, aScale[5], cSayFont, cGetFont, cDefaultFont

cSayFont := Pad('9.Arial',18)
cGetFont := Pad('12.Courier',18)
cDefaultFont := Pad('9.Arial',18)

* aScale := DC_RegQuery( HKEY_CURRENT_USER, 'Software\Donnay Software\eXpress++','Scaling')
* DC_AutoRestoreWindow( { HKEY_CURRENT_USER, 'Software\Donnay Software\eXpress++\Windows' } )

* IF Valtype(aScale) # 'A'
  aScale := Array(5)
  AFill(aScale,1.2)
  aScale[5] := .F.
* ENDIF

@ 1,1 DCSAY 'Column Factor' GET aScale[1] PICTURE '9.99'
@ 2,1 DCSAY 'Row Factor' GET aScale[2] PICTURE '9.99'

@ 4,1 DCSAY 'Width Factor' GET aScale[3] PICTURE '9.99'
@ 5,1 DCSAY 'Height Factor' GET aScale[4] PICTURE '9.99'

@ 7,1 DCSAY 'Say Font' GET cSayFont WHEN {||!aScale[5]}
@ 8,1 DCSAY 'Get Font' GET cGetFont WHEN {||!aScale[5]}
@ 9,1 DCSAY 'Default Font' GET cDefaultFont WHEN {||!aScale[5]}

@11,1 DCCHECKBOX aScale[5] PROMPT 'Use Automatic Font Scaling'

@13,1 DCPUSHBUTTON CAPTION '1' ;
      SIZE 4,1.2 ;
      ACTION {||aScale[1] := .8, ;
                aScale[2] := .8, ;
                aScale[3] := .8, ;
                aScale[4] := .8, ;
                cSayFont := '7.Arial', ;
                cGetFont := '8.Courier New', ;
                cDefaultFont := '7.Arial', ;
                DC_GetRefresh(GetList)}

@DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION '2' ;
      SIZE 4,1.2 ;
      ACTION {||aScale[1] := 1, ;
                aScale[2] := 1, ;
                aScale[3] := 1, ;
                aScale[4] := 1, ;
                cSayFont := '8.Arial', ;
                cGetFont := '10.Courier New', ;
                cDefaultFont := '8.Arial', ;
                DC_GetRefresh(GetList)}

@DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION '3' ;
      SIZE 4,1.2 ;
      ACTION {||aScale[1] := 1.2, ;
                aScale[2] := 1.2, ;
                aScale[3] := 1.2, ;
                aScale[4] := 1.2, ;
                cSayFont := '9.Arial', ;
                cGetFont := '12.Courier New', ;
                cDefaultFont := '9.Arial', ;
                DC_GetRefresh(GetList)}

@DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION '4' ;
      SIZE 4,1.2 ;
      ACTION {||aScale[1] := 1.4, ;
                aScale[2] := 1.4, ;
                aScale[3] := 1.4, ;
                aScale[4] := 1.4, ;
                cSayFont := '10.Arial', ;
                cGetFont := '14.Courier New', ;
                cDefaultFont := '10.Arial', ;
                DC_GetRefresh(GetList)}

@DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION '5' ;
      SIZE 4,1.2 ;
      ACTION {||aScale[1] := 1.6, ;
                aScale[2] := 1.6, ;
                aScale[3] := 1.6, ;
                aScale[4] := 1.6, ;
                cSayFont := '12.Arial', ;
                cGetFont := '17.Courier New', ;
                cDefaultFont := '12.Arial', ;
                DC_GetRefresh(GetList)}

@DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION '6' ;
      SIZE 4,1.2 ;
      ACTION {||aScale[1] := 1.8, ;
                aScale[2] := 1.8, ;
                aScale[3] := 1.8, ;
                aScale[4] := 1.8, ;
                cSayFont := '14.Arial', ;
                cGetFont := '20.Courier New', ;
                cDefaultFont := '14.Arial', ;
                DC_GetRefresh(GetList)}

@DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION '7' ;
      SIZE 4,1.2 ;
      ACTION {||aScale[1] := 2, ;
                aScale[2] := 2, ;
                aScale[3] := 2, ;
                aScale[4] := 2, ;
                cSayFont := '16.Arial', ;
                cGetFont := '24.Courier New', ;
                cDefaultFont := '16.Arial', ;
                DC_GetRefresh(GetList)}

@15,1 DCPUSHBUTTON CAPTION 'Open Scaled Window' SIZE 20,2 ;
      ACTION {||Thread():new():start({||TestWindow(aScale,cSayFont,cGetFont,cDefaultFont)})}

DCGETOPTIONS ;
   SAYWIDTH 80 ;
   SAYRIGHTBOTTOM ;
   TABSTOP

DCREAD GUI FIT ;
   ADDBUTTONS ;
   OPTIONS GetOptions ;
   TITLE 'Scaling Test'

* DC_RegWrite( HKEY_CURRENT_USER, 'Software\Donnay Software\eXpress++','Scaling',aScale)

RETURN nil

* ------------

FUNCTION TestWindow( aScale, cSayFont, cGetFont, cDefaultFont )              && added

Local aTemp := { .T. }

While aTemp[1]
  aTemp := _TestWindow( @aScale, @cSayFont, @cGetFont, @cDefaultFont )
EndDo

Return ( NIL  )

*

FUNCTION _TestWindow( aScale, cSayFont, cGetFont, cDefaultFont )            && changed name

LOCAL GetList[0], GetOptions, oTab1, oTab2, oTab3, cTest := 'This is a Get', ;
      lCheck := .T., nRadio := 1, oBrowse, aDir, cMemo, aBrowPres, ;
      oDialog, cSay, bSay, lOk := .T.                                        && added

aBrowPres := ;
  { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },            /* Header FG Color  */  ;
    { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY },         /* Header BG Color  */  ;
    { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED }, /* Row Sep          */  ;
    { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED }, /* Col Sep          */  ;
    { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },            /* Row FG Color     */  ;
    { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },            /* Row BG Color     */  ;
    { XBP_PP_COL_DA_ROWHEIGHT, 14 },                   /* Row Height       */  ;
    { XBP_PP_COL_HA_HEIGHT, 10 },                      /* Header Height    */  ;
    { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },            /* Hilite FG color  */  ;
    { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },             /* Hilite BG color  */  ;
    { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },            /* Footer FG Color  */  ;
    { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },         /* Footer BG Color  */  ;
    { XBP_PP_COL_FA_HEIGHT, 10 }                       /* Footer Height    */  ;
  }

cMemo := 'This is a memo'

@ 0,0 DCTABPAGE oTab1 SIZE 50,14 CAPTION 'Tab 1' ;
      COLOR GRA_CLR_YELLOW

@ 3,10 DCSAY 'This is a SAY' GET cTest PARENT oTab1 ;
   COLOR GRA_CLR_BLACK, GRA_CLR_WHITE SAYRIGHTCENTER

@ 4,10 DCSAY 'This is a SAY' GET cTest PARENT oTab1 ;
   COLOR GRA_CLR_BLACK, GRA_CLR_BLUE SAYRIGHTCENTER

@ 5,10 DCSAY 'This is a SAY' GET cTest PARENT oTab1 ;
   COLOR GRA_CLR_BLACK, GRA_CLR_WHITE SAYRIGHTCENTER ;
   GETSIZE 20

@ 6,10 DCSAY 'This is a SAY' GET cTest PARENT oTab1  ;
   COLOR GRA_CLR_BLACK, GRA_CLR_BLUE SAYRIGHTCENTER

@ 8,10 DCCHECKBOX lCheck PROMPT 'This is a Checkbox' PARENT oTab1
@ 9,10 DCRADIO nRadio VALUE 1 PROMPT 'This is a Radio Button' PARENT oTab1

@ 11, 5 DCPUSHBUTTON CAPTION 'Button 1' SIZE 10,1.2 PARENT oTab1

@ 11, 20 DCPUSHBUTTON CAPTION 'Button 2' SIZE 10,1.2 PARENT oTab1

@ 11, 35 DCMXPUSHBUTTON CAPTION 'Button 3' SIZE 10,1.2 PARENT oTab1

* -----------

@ 0,0 DCTABPAGE oTab2 RELATIVE oTab1 CAPTION 'Tab 2' ;
      COLOR GRA_CLR_CYAN

@ 2,2 DCMULTILINE cMemo SIZE 46,11 PARENT oTab2

* -----------

@ 0,0 DCTABPAGE oTab3 RELATIVE oTab2 CAPTION 'Tab 3' ;
      COLOR GRA_CLR_WHITE

aDir := Directory()

@ 2,2 DCBROWSE oBrowse DATA aDir SIZE 46,11 ;
      PRESENTATION aBrowPres PARENT oTab3 FIT

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 9 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'File Size' WIDTH 6 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'File Date' WIDTH 6 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'File Time' WIDTH 6 PARENT oBrowse

@ 0, 40 DCSAY 'This is a Say' SAYSIZE 0 COLOR GRA_CLR_RED, GRA_CLR_WHITE



&& added whole block

* 1.0, 1.2, 1.4, 1.6, ...
* wtf 1.44, Val( Str( 1.44, 6, 1 ) ), Val( Str( 1.44, 6, 2 ) )
* wtf 1.68, Val( Str( 1.68, 6, 1 ) ), Val( Str( 1.68, 6, 2 ) )
* wtf 1.92, Val( Str( 1.92, 6, 1 ) ), Val( Str( 1.92, 6, 2 ) )

*           ACTION { || aScale[1] *= 1.2, aScale[2] *= 1.2, aScale[3] *= 1.2, aScale[4] *= 1.2, ;   && added

/*
@ 14.5, 1 DCPUSHBUTTON CAPTION ' + '  SIZE 2,1 ACCELKEY xbeK_CTRL_P ;
          ACTION { || aScale[1] := Val( Str( ( aScale[1] * 1.2 ), 6, 1 ) ), ;
                      aScale[2] := Val( Str( ( aScale[2] * 1.2 ), 6, 1 ) ), ;
                      aScale[3] := Val( Str( ( aScale[3] * 1.2 ), 6, 1 ) ), ;
                      aScale[4] := Val( Str( ( aScale[4] * 1.2 ), 6, 1 ) ), ;
                      oDialog:Hide(), ;
                      dc_pause(0.5), ;                && just for test...
                      oDialog:Configure(), ;
                      oDialog:Show(), ;
                      oDialog:invalidateRect(), ;
                      DC_GetRefresh( GetList ), ;
                      DC_DebugBrowse( { aScale }, {"aScale"}, , , ,  , ,  ), ;
                      MsgBox('+'), ;
                      SetAppFocus( oDialog ) }

@ 14.5, 6 DCPUSHBUTTON CAPTION ' - '  SIZE 2,1 ACCELKEY xbeK_CTRL_M ;
          ACTION { || aScale[1] := Val( Str( ( aScale[1] / 1.2 ), 6, 1 ) ), ;
                      aScale[2] := Val( Str( ( aScale[2] / 1.2 ), 6, 1 ) ), ;
                      aScale[3] := Val( Str( ( aScale[3] / 1.2 ), 6, 1 ) ), ;
                      aScale[4] := Val( Str( ( aScale[4] / 1.2 ), 6, 1 ) ), ;
                      oDialog:Hide(), ;
                      dc_pause(0.5), ;                && just for test...
                      oDialog:Configure(), ;
                      oDialog:Show(), ;
                      oDialog:invalidateRect(), ;
                      DC_GetRefresh( GetList ), ;
                      DC_DebugBrowse( { aScale }, {"aScale"}, , , ,  , ,  ), ;
                      MsgBox('-'), ;
                      SetAppFocus( oDialog ) }
*/

@ 14.5, 1 DCPUSHBUTTON CAPTION ' + '  SIZE 2,1 ACCELKEY xbeK_CTRL_P ;
          ACTION { || ChangeParams( '+', @aScale, @cSayFont, @cGetFont, @cDefaultFont ), ;
                      lOk := .T., ;
                      DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

@ 14.5, 6 DCPUSHBUTTON CAPTION ' - '  SIZE 2,1 ACCELKEY xbeK_CTRL_M ;
          ACTION { || ChangeParams( '-', @aScale, @cSayFont, @cGetFont, @cDefaultFont ), ;
                      lOk := .F., ;
                      DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

* cSay := '{ ||' + Var2Char( aScale ) + '}'
* cSay := '{ ||' + DC_Array2String( aScale ) + '}'
* bSay := &( cSay )
* wtf cSay, bSay
* @ 14.5,10 DCSAY bSay SAYSIZE 30

@ 14.5,10 DCSAY DC_Array2String(aScale)

&& added whole block




DCGETOPTIONS ;
   SAYWIDTH 100 ;
   SAYRIGHTBOTTOM ;
   SAYFONT IIF(aScale[5],nil,Alltrim(cSayFont)) ;
   GETFONT IIF(aScale[5],nil,Alltrim(cGetFont)) ;
   DEFAULTFONT IIF(aScale[5],nil,Alltrim(cDefaultFont)) ;
   SCALEFACTOR aScale ;
   AUTORESIZE

DCREAD GUI FIT ADDBUTTONS OPTIONS GetOptions TITLE DC_Array2String(aScale) ;
       TO lOk ;                                                               && added
       EVAL { |o| oDialog := o, ;                                             && added
                  wtf aScale }                                                && added

wtf aScale, cSayFont, cGetFont, cDefaultFont                                  && added
* RETURN nil                                                                  && removed
RETURN ( { lOk, aScale, cSayFont, cGetFont, cDefaultFont } )                  && added

*

*********************
Function ChangeParams( _cPlusMimus, aScale, cSayFont, cGetFont, cDefaultFont )     && added
*********************

If ( aScale[1] >= 0.6 ) .and. ( aScale[1] <= 2.5 )
   If ( _cPlusMimus == '+' )
      aScale[1] := Val( Str( ( aScale[1] * 1.2 ), 6, 1 ) )
      aScale[2] := Val( Str( ( aScale[2] * 1.2 ), 6, 1 ) )
      aScale[3] := Val( Str( ( aScale[3] * 1.2 ), 6, 1 ) )
      aScale[4] := Val( Str( ( aScale[4] * 1.2 ), 6, 1 ) )
   Else
      aScale[1] := Val( Str( ( aScale[1] / 1.2 ), 6, 1 ) )
      aScale[2] := Val( Str( ( aScale[2] / 1.2 ), 6, 1 ) )
      aScale[3] := Val( Str( ( aScale[3] / 1.2 ), 6, 1 ) )
      aScale[4] := Val( Str( ( aScale[4] / 1.2 ), 6, 1 ) )
   EndIf
EndIf

If ( aScale[1] < 0.8 ) .or. ( aScale[1] > 2.4 )
   aScale[1] := 1.0
   aScale[2] := 1.0
   aScale[3] := 1.0
   aScale[4] := 1.0
   cSayFont := '8.Arial'
   cGetFont := '10.Courier New'
   cDefaultFont := '8.Arial'
ElseIf ( aScale[1] <= 0.8 )
   cSayFont := '7.Arial'
   cGetFont := '8.Courier New'
   cDefaultFont := '7.Arial'
ElseIf ( aScale[1] <= 1.0 )
   cSayFont := '8.Arial'
   cGetFont := '10.Courier New'
   cDefaultFont := '8.Arial'
ElseIf ( aScale[1] <= 1.2 )
   cSayFont := '9.Arial'
   cGetFont := '12.Courier New'
   cDefaultFont := '9.Arial'
ElseIf ( aScale[1] <= 1.4 )
   cSayFont := '10.Arial'
   cGetFont := '14.Courier New'
   cDefaultFont := '10.Arial'
ElseIf ( aScale[1] <= 1.6 )
   cSayFont := '12.Arial'
   cGetFont := '17.Courier New'
   cDefaultFont := '12.Arial'
ElseIf ( aScale[1] <= 1.8 )
   cSayFont := '14.Arial'
   cGetFont := '20.Courier New'
   cDefaultFont := '14.Arial'
ElseIf ( aScale[1] <= 2.0 )
   cSayFont := '16.Arial'
   cGetFont := '24.Courier New'
   cDefaultFont := '16.Arial'
ElseIf ( aScale[1] <= 2.4 )
   cSayFont := '18.Arial'
   cGetFont := '26.Courier New'
   cDefaultFont := '18.Arial'
EndIf

Return ( NIL )

*

